//**********************************************//
//******************KAmodCOLOR******************//
//**********************************************//

//****************LCD - ZL27ARM*****************//
//LCD_D0 - JP10(PE0)
//LCD_D1 - JP10(PE1)
//LCD_D2 - JP10(PE2)
//LCD_D3 - JP10(PE3)
//LCD_D4 - JP10(PE4)
//LCD_D5 - JP10(PE5)
//LCD_D6 - JP10(PE6)
//LCD_D7 - JP10(PE7)
//LCD_RS - JP10(PE8)
//LCD_RW - JP10(PE9)
//LCD_EN - JP10(PE10)
//LCD_+V - JP10(+3.3V)
//LCD_GND - JP10(GND)

//**************KAmodCOLOR - ZL27ARM*************//
//Con1_Fo - JP6(PA0)
//Con1_S0 - JP6(PA2)
//Con1_S1 - JP6(PA3)
//Con1_S2 - JP6(PA4)
//Con1_S3 - JP6(PA5)
//Con1_OE - JP6(PA6)
//Con1_LED - JP6(PA7)
//Con1_+V - JP6(+3.3V)
//Con1_GND - JP6(GND)



#include <stddef.h>
#include "stm32f10x.h"
#include "defines.h"

int tmp;
int i;
uint16_t licznik = 0;
char tmp1=0;

char stanLED=1;

uint16_t FreqRed = 0;
uint16_t FreqGreen = 0;
uint16_t FreqBlue = 0;
uint16_t FreqClear = 0;
unsigned char Clear0=0;
unsigned char Clear1=0;
unsigned char Clear2=0;
unsigned char Clear3=0;
unsigned char R0=0;
unsigned char R1=0;
unsigned char R2=0;
unsigned char R3=0;
unsigned char G0=0;
unsigned char G1=0;
unsigned char G2=0;
unsigned char G3=0;
unsigned char B0=0;
unsigned char B1=0;
unsigned char B2=0;
unsigned char B3=0;


RCC_ClocksTypeDef RCC_Clocks;
TIM_TimeBaseInitTypeDef TIM_TimeBaseStructure;

void Configuration_RCC(void);
void Configuration_Interrupts(void);
void Configuration_GPIO(void);

int main(void)
{
	//konfiguracje
	Configuration_RCC();
	Configuration_Interrupts();
	Configuration_GPIO();

	//ustawienie nEO
	TCS3200_DISABLE;
	//wybranie filtru - brak
	TCS3200_Clear;
	//ustawienie skali czstotliwosci
	TCS3200_Freq_100p;
	//wlaczenie diod LED
	TCS3200_LED_ON;

	//konfiguracja licznika TIM2
	TIM_TimeBaseStructure.TIM_Period = 9999;
	TIM_TimeBaseStructure.TIM_Prescaler = 0;
	TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;
	TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;
	TIM_TimeBaseInit(TIM2, &TIM_TimeBaseStructure);

	//konfiguracja sygnau taktujacego TIM2
	TIM_TIxExternalClockConfig(TIM2, TIM_TIxExternalCLK1Source_TI1, TIM_ICPolarity_Rising, 0x0);

	//wlaczenie licznika
	TIM_Cmd(TIM2, ENABLE);

	//pobranie informacji o czstotliwosci
	RCC_GetClocksFreq(&RCC_Clocks);

	//konfiguracja SysTick
	SysTick_Config(RCC_Clocks.SYSCLK_Frequency/100);

	//inicjalizacja wuwietlacza
	LCD_Initialize();
	
	//aktualizacja informacji wyswietlanych na wyswietlaczu	
	LCD_WriteCommand(HD44780_CLEAR);
	LCD_WriteTextXY("Clear=0000  LED=ON ",0,0);
	LCD_WriteTextXY("R=0000 G=0000 B=0000",0,1);

	//nieskoczona ptla
	while (1)
	{
		//aktualizacja informacji, filtr - Clear
		tmp = FreqClear;
		Clear3=(tmp % 10) + 0x30;//jednosci
		tmp = tmp /10;
		Clear2=(tmp % 10) + 0x30;//dziesiatki
		tmp = tmp / 10;
		Clear1=(tmp % 10) + 0x30;//setki
		tmp = tmp / 10;
		Clear0=(tmp % 10) + 0x30;//tysiace

		//aktualizacja informacji, filtr - Red
		tmp = FreqRed;
		R3=(tmp % 10) + 0x30;
		tmp = tmp /10;
		R2=(tmp % 10) + 0x30;
		tmp = tmp / 10;
		R1=(tmp % 10) + 0x30;
		tmp = tmp / 10;
		R0=(tmp % 10) + 0x30;

		//aktualizacja informacji, filtr - Green
		tmp = FreqGreen;
		G3=(tmp % 10) + 0x30;
		tmp = tmp /10;
		G2=(tmp % 10) + 0x30;
		tmp = tmp / 10;
		G1=(tmp % 10) + 0x30;
		tmp = tmp / 10;
		G0=(tmp % 10) + 0x30;

		//aktualizacja informacji, filtr - Blue
		tmp = FreqBlue;
		B3=(tmp % 10) + 0x30;
		tmp = tmp /10;
		B2=(tmp % 10) + 0x30;
		tmp = tmp / 10;
		B1=(tmp % 10) + 0x30;
		tmp = tmp / 10;
		B0=(tmp % 10) + 0x30;

	//Wyswietlenie danych na OLED
	LCD_GoTo(6,0);
	LCD_WriteData(Clear0);//tysiace
	LCD_WriteData(Clear1);//setki
	LCD_WriteData(Clear2);//dziesiatki
	LCD_WriteData(Clear3);//jednosci
	LCD_GoTo(2,1);
	LCD_WriteData(R0);
	LCD_WriteData(R1);
	LCD_WriteData(R2);
	LCD_WriteData(R3);
	LCD_GoTo(9,1);
	LCD_WriteData(G0);
	LCD_WriteData(G1);
	LCD_WriteData(G2);
	LCD_WriteData(G3);
	LCD_GoTo(16,1);
	LCD_WriteData(G0);
	LCD_WriteData(B1);
	LCD_WriteData(B2);
	LCD_WriteData(B3);
	
	//Kontrola diody LED (podswietlenie)
	if (!GPIO_ReadInputDataBit(GPIOA,GPIO_Pin_1)&&tmp1>=5)
		{			
			//Opuznienie dla przycisku
			for(i=0;i<10000;i++);
			//Ponowne spr. stanu SW1
			if (!GPIO_ReadInputDataBit(GPIOA,GPIO_Pin_1))
			{
				//Zmiana stanu LED
				if(stanLED)
				{
					LCD_WriteTextXY("OFF",16,0);
					//Wylaczenie LED
					GPIO_ResetBits(GPIOA, GPIO_Pin_7);
					stanLED=0;
				}
				else
				{
					LCD_WriteTextXY("ON ",16,0);
					//Wlaczenie LED
					GPIO_SetBits(GPIOA, GPIO_Pin_7);
					stanLED=1;
				}
				tmp1=0;
			}
		}
		
		//minimalny odstep czasu miedzy spr. stanu przycisku
		tmp1++;
		if (tmp1>=5) tmp1=7;
		
		//opuznienie dla LCD
		for(i=0;i<100000;i++);
			
	}
		
}

void Configuration_RCC(void)
{
	ErrorStatus HSEStartUpStatus;

	//Reset ustawien RCC
	RCC_DeInit();

	//Wlaczaenie HSE
	RCC_HSEConfig(RCC_HSE_ON);

	//Zaczekaj az HSE zostanie zainicjowany
	HSEStartUpStatus = RCC_WaitForHSEStartUp();

	//jesli HSE zosta zainicjalizowany poprawnie
	if(HSEStartUpStatus == SUCCESS)
	{
		//Opoznienie dla pamieci Flash
		FLASH_SetLatency(FLASH_Latency_2);

		//Wlaczenie buffora pamieci flash
		FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable);

		//konfiguracja preskalera AHB
		//HCLK = SYSCLK
		RCC_HCLKConfig(RCC_SYSCLK_Div1);

		//konfigracja preskalera APB2
	    //PCLK2 = HCLK = 72MHz, czestotliwosz 72MHz bedzie uzyskana dopiero po pelnej inicjalizacji RCC
		RCC_PCLK2Config(RCC_HCLK_Div1);

	    //konfigracja preskalera APB1
		//PCLK1 = HCLK/2 = 36MHz, czestotliwosz 36MHz bedzie uzyskana dopiero po pelnej inicjalizacji RCC
		RCC_PCLK1Config(RCC_HCLK_Div2);

	    //konfiguracja PLLLCK
		//PLLCLK = HSE / 1 * 9 = 72 MHz
		RCC_PLLConfig(RCC_PLLSource_HSE_Div1, RCC_PLLMul_9);

		//Enable PLL
	    RCC_PLLCmd(ENABLE);

	    //odczekanie az PLL bedzie gotowy do pracy
	    while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET){}

	    //konfiguracja SW
		//wybranie PLL jako SYSCLK
		RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);

	    //odczekanie az PLLCLK bedzie sygnaem zegarowym mikrokontrolera
	    while((RCC->CFGR & (uint32_t)RCC_CFGR_SWS) != (uint32_t)0x08){}
	}

	//wczenie zegarw wykorzystywanych peryferii APB1
	RCC_APB1PeriphClockCmd(
		RCC_APB1Periph_TIM2 |
		RCC_APB1Periph_TIM3
		, ENABLE);

	//wczenie zegarw wykorzystywanych peryferii APB2
	RCC_APB2PeriphClockCmd(
		RCC_APB2Periph_TCS3200 |
		RCC_APB2Periph_AFIO |
		RCC_APB2Periph_GPIOB | RCC_APB2Periph_GPIOE
		, ENABLE);
}

void Configuration_Interrupts(void)
{
	//zdefiniowanie struktury wykorzystywanej do konfiguracji przerwani
	NVIC_InitTypeDef NVIC_InitStructure;

	// W przeciwnym wypadku ustaw na 0x08000000
	NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x0);
}

void Configuration_GPIO(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;

	//inicjalizacja GPIO - S0, S1, S2, S3, nEO, LED
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Pin =	GPIO_Pin(TCS3200_PIN_S0) |
									GPIO_Pin(TCS3200_PIN_S1) |
									GPIO_Pin(TCS3200_PIN_S2) |
									GPIO_Pin(TCS3200_PIN_S3) |
									GPIO_Pin(TCS3200_PIN_nOE) |
									GPIO_Pin(TCS3200_PIN_LED);
	GPIO_Init(GPIO_TCS3200, &GPIO_InitStructure);

	//inicjalizacja GPIO - OUT
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Pin = TCS3200_PIN_OUT;
	GPIO_Init(GPIO_TCS3200, &GPIO_InitStructure);
	
	//Przycisk do LED
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
  GPIO_Init(GPIOA, &GPIO_InitStructure);

}

#ifdef  USE_FULL_ASSERT

/**
  * @brief  Reports the name of the source file and the source line number
  *   where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif

/*
 * Minimal __assert_func used by the assert() macro
 * */
void __assert_func(const char *file, int line, const char *func, const char *failedexpr)
{
  while(1)
  {}
}

/*
 * Minimal __assert() uses __assert__func()
 * */
void __assert(const char *file, int line, const char *failedexpr)
{
   __assert_func (file, line, NULL, failedexpr);
}

#ifdef USE_SEE
#ifndef USE_DEFAULT_TIMEOUT_CALLBACK
/**
  * @brief  Basic management of the timeout situation.
  * @param  None.
  * @retval sEE_FAIL.
  */
uint32_t sEE_TIMEOUT_UserCallback(void)
{
  /* Return with error code */
  return sEE_FAIL;
}
#endif
#endif /* USE_SEE */

